DocMkrParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
DocMkrParser Class Reference

the main class to read a DocMake file More...

`#include <DocMkrParser.hxx>`

Inheritance diagram for DocMkrParser:

## Public Member Functions
| DocMkrParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~DocMkrParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGTextInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWTextParser
virtual | ~MWAWTextParser ()
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | init ()
| inits all internal variables More...
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document More...
MWAWVec2f | getPageLeftTop () const
| returns the page left top point ( in inches) More...
void | newPage (int number)
| adds a new page More...
bool | createZones ()
| finds the different objects zones More...
bool | readPictInfo (MWAWEntry const &entry)
| try to read a pict info zone ? ( resource pInf ) More...
bool | readSTwD (MWAWEntry const &entry)
| try to read an unknown zone ( resource sTwD ) More...
bool | readXtr2 (MWAWEntry const &entry)
| try to read an unknown zone ( resource xtr2 ) More...
bool | sendPicture (int zId, int lId, double lineW)
| try to send a picture knowing zId and local id More...
void | flushExtra ()
| sends the data which have not yet been sent to the listener More...
MWAWInputStreamPtr | rsrcInput ()
| return the input input More...
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc More...
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWTextParser (MWAWParserStatePtr state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
shared_ptr< DocMkrParserInternal::State > | m_state
| the state More...
shared_ptr< DocMkrText > | m_textParser
| the text parser More...

## Friends
class | DocMkrText

## Detailed Description

the main class to read a DocMake file

## Constructor & Destructor Documentation

## ◆ DocMkrParser()

DocMkrParser::DocMkrParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~DocMkrParser()

DocMkrParser::~DocMkrParser | ( |  | ) |
| virtual

destructor

## Member Function Documentation

## ◆ checkHeader()

bool DocMkrParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| virtual

checks if the document header is correct (or not)

no data fork, may be ok, but this means that the file contains no text, so...

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void DocMkrParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool DocMkrParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ flushExtra()

void DocMkrParser::flushExtra | ( |  | ) |
| protected

sends the data which have not yet been sent to the listener

Referenced by parse().

## ◆ getPageLeftTop()

MWAWVec2f DocMkrParser::getPageLeftTop | ( |  | ) | const
| protected

returns the page left top point ( in inches)

## ◆ init()

void DocMkrParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by DocMkrParser().

## ◆ newPage()

void DocMkrParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by DocMkrText::sendMainText(), and DocMkrText::sendText().

## ◆ parse()

void DocMkrParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| virtual

virtual function used to parse the input

Implements MWAWTextParser.

## ◆ readPictInfo()

bool DocMkrParser::readPictInfo | ( | MWAWEntry const & | entry | ) |
| protected

try to read a pict info zone ? ( resource pInf )

Referenced by createZones().

## ◆ readSTwD()

bool DocMkrParser::readSTwD | ( | MWAWEntry const & | entry | ) |
| protected

try to read an unknown zone ( resource sTwD )

Referenced by createZones().

## ◆ readXtr2()

bool DocMkrParser::readXtr2 | ( | MWAWEntry const & | entry | ) |
| protected

try to read an unknown zone ( resource xtr2 )

Referenced by createZones().

## ◆ rsrcAscii()

libmwaw::DebugFile & DocMkrParser::rsrcAscii | ( |  | ) |
| protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by createZones(), DocMkrText::readFontNames(), DocMkrText::readFooter(), readPictInfo(), readSTwD(), DocMkrText::readStyles(), DocMkrText::readTOC(), DocMkrText::readWindows(), readXtr2(), and DocMkrText::sendText().

## ◆ rsrcInput()

MWAWInputStreamPtr DocMkrParser::rsrcInput | ( |  | ) |
| protected

return the input input

Referenced by DocMkrText::computeNumPages(), DocMkrText::readFontNames(), DocMkrText::readFooter(), readPictInfo(), readSTwD(), DocMkrText::readStyles(), DocMkrText::readTOC(), DocMkrText::readWindows(), readXtr2(), DocMkrText::sendComment(), DocMkrText::sendFooter(), sendPicture(), DocMkrText::sendText(), and DocMkrText::updatePageSpanList().

## ◆ sendPicture()

bool DocMkrParser::sendPicture | ( | int | zId,
|  | int | lId,
|  | double | lineW
| ) |  |
| protected

try to send a picture knowing zId and local id

Referenced by DocMkrText::sendText().

## Friends And Related Function Documentation

## ◆ DocMkrText

friend class DocMkrText
| friend

Referenced by init().

## Member Data Documentation

## ◆ m_state

shared_ptr<DocMkrParserInternal::State> DocMkrParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), flushExtra(), init(), newPage(), readPictInfo(), and sendPicture().

## ◆ m_textParser

shared_ptr<DocMkrText> DocMkrParser::m_textParser
| protected

the text parser

Referenced by createDocument(), createZones(), init(), parse(), and sendPicture().

The documentation for this class was generated from the following files:

- DocMkrParser.hxx
- DocMkrParser.cxx